org.apache.lucene.search

## Class Sort

- java.lang.Object
- - org.apache.lucene.search.Sort

    public class Sort
    extends Object

Encapsulates sort criteria for returned hits.

The fields used to determine sort order must be carefully chosen. Documents must contain a single term in such a field, and the value of the term should indicate the document's relative position in a given sort order. The field must be indexed, but should not be tokenized, and does not need to be stored (unless you happen to want it back with the rest of your document data). In other words:

`document.add (new Field ("byNumber", Integer.toString(x), Field.Store.NO, Field.Index.NOT_ANALYZED));`

### Valid Types of Values

There are four possible kinds of term values which may be put into sorting fields: Integers, Longs, Floats, or Strings. Unless `SortField` objects are specified, the type of value in the field is determined by parsing the first term in the field.

Integer term values should contain only digits and an optional preceding negative sign. Values must be base 10 and in the range `Integer.MIN_VALUE` and `Integer.MAX_VALUE` inclusive. Documents which should appear first in the sort should have low value integers, later documents high values (i.e. the documents should be numbered `1..n` where `1` is the first and `n` the last).

Long term values should contain only digits and an optional preceding negative sign. Values must be base 10 and in the range `Long.MIN_VALUE` and `Long.MAX_VALUE` inclusive. Documents which should appear first in the sort should have low value integers, later documents high values.

Float term values should conform to values accepted by `Float.valueOf(String)` (except that `NaN` and `Infinity` are not supported). Documents which should appear first in the sort should have low values, later documents high values.

String term values can contain any valid String, but should not be tokenized. The values are sorted according to their `natural order`. Note that using this type of term value has higher memory requirements than the other two types.

### Object Reuse

One of these objects can be used multiple times and the sort order changed between usages.

This class is thread safe.

### Memory Usage

Sorting uses of caches of term values maintained by the internal HitQueue(s). The cache is static and contains an integer or float array of length `IndexReader.maxDoc()` for each field name for which a sort is performed. In other words, the size of the cache in bytes is:

`4 * IndexReader.maxDoc() * (# of different fields actually used to sort)`

For String fields, the cache is larger: in addition to the above array, the value of every term in the field is kept in memory. If there are many unique terms in the field, this could be quite large.

Note that the size of the cache is not affected by how many fields are in the index and might be used to sort - only by the ones actually used to sort a result set.

Created: Feb 12, 2004 10:53:57 AM

Since:
  lucene 1.4

### Field Summary

Fields
`static Sort` `INDEXORDER` Represents sorting by index order.
`static Sort` `RELEVANCE` Represents sorting by computed relevance.

### Constructor Summary

Constructors
Constructor and Description
`Sort()` Sorts by computed relevance.
`Sort(SortField... fields)` Sets the sort to the given criteria in succession: the first SortField is checked first, but if it produces a tie, then the second SortField is used to break the tie, etc.
`Sort(SortField field)` Sorts by the criteria in the given SortField.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `equals(Object o)` Returns true if `o` is equal to this.
`SortField[]` `getSort()` Representation of the sort criteria.
`int` `hashCode()` Returns a hash code value for this object.
`boolean` `needsScores()` Returns true if the relevance score is needed to sort documents.
`Sort` `rewrite(IndexSearcher searcher)` Rewrites the SortFields in this Sort, returning a new Sort if any of the fields changes during their rewriting.
`void` `setSort(SortField... fields)` Sets the sort to the given criteria in succession: the first SortField is checked first, but if it produces a tie, then the second SortField is used to break the tie, etc.
`void` `setSort(SortField field)` Sets the sort to the given criteria.
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### RELEVANCE

    public static final Sort RELEVANCE

Represents sorting by computed relevance. Using this sort criteria returns the same results as calling `IndexSearcher#search()`without a sort criteria, only with slightly more overhead.

#### INDEXORDER

    public static final Sort INDEXORDER

Represents sorting by index order.

### Constructor Detail

#### Sort

    public Sort()

Sorts by computed relevance. This is the same sort criteria as calling `IndexSearcher#search()`without a sort criteria, only with slightly more overhead.

#### Sort

    public Sort(SortField field)

Sorts by the criteria in the given SortField.

#### Sort

    public Sort(SortField... fields)

Sets the sort to the given criteria in succession: the first SortField is checked first, but if it produces a tie, then the second SortField is used to break the tie, etc. Finally, if there is still a tie after all SortFields are checked, the internal Lucene docid is used to break it.

### Method Detail

#### setSort

    public void setSort(SortField field)

Sets the sort to the given criteria.

#### setSort

    public void setSort(SortField... fields)

Sets the sort to the given criteria in succession: the first SortField is checked first, but if it produces a tie, then the second SortField is used to break the tie, etc. Finally, if there is still a tie after all SortFields are checked, the internal Lucene docid is used to break it.

#### getSort

    public SortField[] getSort()

Representation of the sort criteria.

Returns:
  Array of SortField objects used in this sort criteria

#### rewrite

    public Sort rewrite(IndexSearcher searcher)
                 throws IOException

Rewrites the SortFields in this Sort, returning a new Sort if any of the fields changes during their rewriting.

Parameters:
  `searcher` - IndexSearcher to use in the rewriting
Returns:
  `this` if the Sort/Fields have not changed, or a new Sort if there is a change
Throws:
  `IOException` - Can be thrown by the rewriting
WARNING: This API is experimental and might change in incompatible ways in the next release.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### equals

    public boolean equals(Object o)

Returns true if `o` is equal to this.

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Returns a hash code value for this object.

Overrides:
  `hashCode` in class `Object`

#### needsScores

    public boolean needsScores()

Returns true if the relevance score is needed to sort documents.